
/*
 * Copyright Attribution.  Each Licensee Product shall display, in a 
 * user-visible location such as a start-up screen or an "About" box, 
 * and in a message to be displayed on-screen at the time Licensee 
 * Products are installed on an end-user system, the following legend, 
 * which shall be displayed for at least two (2) seconds.
 * 
 * 	"PXE Software Copyright (C) 1999  Intel Corporation"
 */

/*
 *
 * Modifications:   $Header:   H:/Archives/Client/Include/bootp.h_v   1.7   22 M
ay 1998 21:17:54   MJOHNSOX  $
 *
 * Copyright(c) 1999 by Intel Corporation.  All Rights Reserved.
 *
 * BOOTP.H - defines for the BOOTP protocol 
 */

#ifndef __BOOTP_H
#define __BOOTP_H

#define	BOOTP_VENDOR	64	/* BOOTP standard vendor field size */
#define BOOTP_MIN	264
#define	BOOTP_DHCPVEND 	312	/* DHCP standard vendor field size */
#define	BOOTP_EXVENDOR	1024	/* .. our max. size (MTU 1500) */

#ifndef IPLEN
#define IPLEN	4
#endif

/* BOOTstrap Protocol (BOOTP) header */
struct bootph {
	BYTE	opcode,			/* operation code */
		hardware,		/* hardware type */
		hardlen,		/* length of hardware address */
		gatehops;		/* gateways hops */
	ULONG	ident;			/* transaction identification */
	USHORT	seconds,		/* seconds elapsed since boot began */
		flags;			/* flags */
	BYTE	cip[IPLEN],		/* client IP address */
		yip[IPLEN],		/* your IP address */
		sip[IPLEN],		/* server IP address */
		gip[IPLEN];		/* gateway IP address */
	BYTE	caddr[16],		/* client hardware address */
		sname[64],		/* server name */
		bootfile[128];		/* bootfile name */
	union {
		BYTE	d[BOOTP_EXVENDOR];	/* vendor-specific stuff */
		struct {
			BYTE	magic[4];	/* magic number */
			ULONG	flags;		/* flags/opcodes etc */
			BYTE	pad[56];	/* padding chars */
		} v;
	} vendor;
};
typedef struct bootph	BOOTPLAYER;
#define	VM_RFC1048	0x63825363L	/* RFC1048 magic number */
#define	BOOTP_SPORT	67		/* BOOTP server port */
#define	BOOTP_CPORT	68		/* .. client port */
#define	BOOTP_REQ	1		/* BOOTP request */
#define	BOOTP_REP	2		/* .. reply */
#define	BOOTP_ETHER	1		/* .. ethernet hardware */
#define	BOOTP_IEEE	6		/* .. IEEE 802 hardware */

/* BOOTP flags field */
#define	BOOTP_BCAST	0x8000		/* BOOTP broadcast flag */
#define	BOOTP_FLAGS	BOOTP_BCAST 	/* .. for FDDI address transl. */
#undef IPLEN				/* To avoid conflict with ip.h */
#endif
