
/*
 * Copyright Attribution.  Each Licensee Product shall display, in a 
 * user-visible location such as a start-up screen or an "About" box, 
 * and in a message to be displayed on-screen at the time Licensee 
 * Products are installed on an end-user system, the following legend, 
 * which shall be displayed for at least two (2) seconds.
 * 
 * 	"PXE Software Copyright (C) 1999  Intel Corporation"
 */

#include "cproxreg.h"

#ifndef _H_CPXEDEBUG_H__
#define _H_CPXEDEBUG_H__

#define PXE_PARSER_DEBUG		1
#define PXE_SERVICES_DEBUG		2
#define PXE_TESTER_DEBUG		3
#define PXE_MTFTP_DEBUG			4

#define DEBUG_ROOT_PATH					_T("DEBUG")

#define DEBUG_SERVICES_FILENAME			_T("PxeServices_Debug_FileName")
#define DEBUG_PARSERS_FILENAME			_T("PxeParsers_Debug_FileName")
#define DEBUG_MTFTP_FILENAME			_T("PxeMtftp_Debug_FileName")
#define DEBUG_TESTER_FILENAME	_T("PxeTester_Debug_FileName")

#define DEBUG_SERVICES_ON		_T("PxeServices_DebugOutToFile_On")
#define DEBUG_PARSERS_ON		_T("PxeParsers_DebugOutToFile_On")
#define DEBUG_TESTER_ON			_T("PxeTester_DebugOutToFile_On")
#define DEBUG_MTFTP_ON			_T("PxeMtftp_DebugOutToFile_On")

#define ODS_SERVICES_ON			_T("PxeServices_DebugOutToWindow_On")
#define ODS_PARSERS_ON			_T("PxeParsers_DebugOutToWindow_On")
#define ODS_TESTER_ON			_T("PxeTester_DebugOutToWindow_On")
#define ODS_MTFTP_ON			_T("PxeMtftp_DebugOutToWindow_On")

#define DEFAULT_SERVICES_LOGFILE		_T("/PxeServicesDebugLog.Txt")
#define DEFAULT_PARSERS_LOGFILE			_T("/PxeParsersDebugLog.Txt")
#define DEFAULT_TESTER_LOGFILE			_T("/PxeTesterDebugLog.Txt")
#define DEFAULT_MTFTP_LOGFILE			_T("/PxeMtftpDebugLog.Txt")

#define ERRLOG_SOCKET_ERROR			1
#define ERRLOG_GENERIC_ERROR		2

class CPxeDebug
{
public:
	CPxeDebug();
//	~CPxeDebug();

	BOOL init(int nType);
	int write(char *lpszFormat, ... );
	int logError(char *lpszFormat, ... );
	int logError(int nMsgId, char *lpszFormat, ... );
	void HexDump (unsigned char *buf, int nSize);
	BOOL close();
	BOOL DebugOn();

private:

	int			m_nType;
	BOOL		bDebugOutToWindow;
	BOOL		bDebugOutToFile;
	FILE*		m_fp;
	CRegistry	*m_pReg;


};

#endif
