
/*
 * Copyright Attribution.  Each Licensee Product shall display, in a 
 * user-visible location such as a start-up screen or an "About" box, 
 * and in a message to be displayed on-screen at the time Licensee 
 * Products are installed on an end-user system, the following legend, 
 * which shall be displayed for at least two (2) seconds.
 * 
 * 	"PXE Software Copyright (C) 1999  Intel Corporation"
 */


#ifndef _REGISTRY_H_
#define _REGISTRY_H_


// some global functions.

class /*AFX_EXT_CLASS*/ CRegistry 
{

	CString m_ostrServerName;
	HKEY	m_hRegKey;
	BOOL	m_bIsValid;		// is this m_hRegKey valid
	LPBYTE m_lpData;		// internal buffer.
	


public :
	
	CRegistry ();
	virtual ~CRegistry ();

	BOOL ReadRegString		( LPCTSTR path,		LPCTSTR field,		CString *pstrData) const;
	BOOL ReadRegMultiString ( LPCTSTR p_lpPath, LPCTSTR p_lpField, CStringArray *p_pkroarrStrings) const;
	BOOL ReadRegDWord		( LPCTSTR p_lpPath, LPCTSTR p_lpField,  DWORD *p_pdwVal) const;
	BOOL IsConnected();


	// set a machine name.
	BOOL ConnectTo (HKEY p_hKey, const TCHAR *p_pkszMachine  = NULL ) ;

	// When this class doesnt do what you want to do get the handle.
	BOOL GetHandleToHive (HKEY *p_phKey);

	FILE *OpenRegistry() const;
	BOOL FindRegEntry(FILE *fp, LPCTSTR p_lpPath, LPCTSTR p_lpField) const;
	BOOL ReadDwordValue(FILE *fp, DWORD* p_pdwVal) const;
	BOOL ReadStringValue(FILE *fp, CString* p_pstrData) const;
	BOOL ReadMultiStringValues(FILE *fp, CStringArray* pArray) const;
	BOOL ReadNextValueLine(FILE* fp, char* buf) const;

};

#endif // _REGISTRY_H_

// eof.
