
/*
 * Copyright Attribution.  Each Licensee Product shall display, in a 
 * user-visible location such as a start-up screen or an "About" box, 
 * and in a message to be displayed on-screen at the time Licensee 
 * Products are installed on an end-user system, the following legend, 
 * which shall be displayed for at least two (2) seconds.
 * 
 * 	"PXE Software Copyright (C) 1999  Intel Corporation"
 */

#include "pxemisc.h"
#include "dhcp.h"
#include "pxe.h"
#include "cdhcp.h"
#include "cproxreg.h"
#include "optsdll.h"

#define APITEST_SERVER_TAG	179
#define APITEST_DOMAIN_TAG 180
#define APITEST_WRKGRP_TAG 181

extern "C" DWORD Options(PXE_OPTIONS_DATA* p_data)
{
	CString csDomainName;
	BYTE ucDomainLen;
	CString csServerName;
	BYTE ucServerLen;
	BOOL bIsDomain;
	int nStartPktSize = 0;
	BYTE ucOptBuf[256];
	CProxyRegistry ProxyReg;


	// Convert byte arrays to CDhcp objects.
	CDhcp ClientPkt(p_data->ucClientPkt, p_data->usClientSize);
	CDhcp ReplyPkt(p_data->ucReplyPkt, p_data->usReplySize);
	nStartPktSize = p_data->usReplySize;

//	csDomainName = ApiTestReg.DomainName();
//	csServerName = ApiTestReg.ServerName();
//	bIsDomain = ApiTestReg.IsDomain();

	ProxyReg.GetMachineInfo(&csServerName, &csDomainName, bIsDomain);
	ucDomainLen = (BYTE)(csDomainName.length() +1);
	ucServerLen = (BYTE)(csServerName.length() +1);

	// SERVER NAME
	strcpy((char*)ucOptBuf, csServerName);
	ucOptBuf[ucServerLen-1] = 0;
	ReplyPkt.Add43Option(APITEST_SERVER_TAG, ucOptBuf, ucServerLen);

	// DOMAIN NAME
	strcpy((char*)ucOptBuf, csDomainName);
	ucOptBuf[ucDomainLen-1] = 0;
	ReplyPkt.Add43Option((bIsDomain ? BYTE(APITEST_DOMAIN_TAG) : BYTE(APITEST_WRKGRP_TAG)),
										ucOptBuf, ucDomainLen);
	{ 
		// Convert the DHCP class object to a BYTE array for returning.
		int nPacketSize = ReplyPkt.PacketLength() + 100;
		BYTE* DhcpPacket = new (BYTE [nPacketSize]);
		memset(DhcpPacket, 0, nPacketSize);
		ReplyPkt.GetPacket(DhcpPacket, nPacketSize);
		if (nPacketSize <= p_data->usReplyMaxSize)
		{
			memcpy(p_data->ucReplyPkt, DhcpPacket, nPacketSize);
			p_data->usReplySize = USHORT(nPacketSize);
		} else
		{	// Not all of the packet will fit so copy what will fit.
			memcpy(p_data->ucReplyPkt, DhcpPacket, p_data->usReplyMaxSize);
			p_data->usReplySize = p_data->usReplyMaxSize;
		}

		delete[] DhcpPacket;
	}
	return (p_data->usReplySize - nStartPktSize);
}
